function install(varargin)
% 'mfile' 
% install('name','eigs')
  assert(nargin>=2)
  p = inputParser; 
  p.addParamValue('name', '', @ischar );
  p.addParamValue('version', '', @ischar );
  p.addParamValue('verbose', false, @islogical );
%  p.addParamValue('url', '', @ischar );
%  p.addParamValue('mfile','' , @ischar );
  p.parse(varargin{:});
  R=p.Results;
  Versions=fc_vfemp1.addon.findCompatibleVersions(R.name);
  if isempty(Versions), fprintf('[fc-vfemp1] Addon %s installation failed!',R.name);return;end
  if ~isempty(R.version)
    if ismember(R.version,Versions)
      version=R.version;
    else
      fprintf('[fc-vfemp1] Addon %s version %s not compatible with fc-vfemp1 version %s!',R.name,R.version,fc_vfemp1.version());return;
    end
  else
    version=Versions{end};
  end
  isOctave=fc_tools.comp.isOctave();
  base=sprintf('fc-vfemp1-%s-%s',R.name,version);
  fullname=mfilename('fullpath');
  I=strfind(fullname,filesep);
  Path=fullname(1:(I(end)-1));
  
  alreadyinstalled=true;
  try
    eval(sprintf('locver=fc_vfemp1.addon.%s.version();',R.name))
  catch
    alreadyinstalled=false;
  end
  if alreadyinstalled
    fprintf('[fc-vfemp1] Addon %s version %s already installed!',R.name,locver)
    return
  end
  instDir=[Path,filesep,'+',R.name];
  if fc_tools.sys.isfolder(instDir)
    fprintf('[fc-vfemp1] Cannot install <%s> addon, directory already exists:\n     -> %s\n',R.name,instDir)
    return
  end
  
  urlbase=fc_vfemp1.addon.getUrl();
  urlfile=[urlbase,R.name,filesep,version,filesep,base,'.tar.gz'];
  archfile=fc_tools.utils.getWebFile(urlfile);
  env=fc_vfemp1.environment();
  try
    filelist=untar(archfile,env.Path);
  catch
    error('[fc-vfemp1] Unable to untar :\n  -> %s\n',urlfile);
  end
    
  filename=[Path,filesep,R.name,'-filelist'];
  fid=fopen(filename,'w');
  for i=1:length(filelist)
    
    fprintf(fid,'%s\n',filelist{i});
  end
  fclose(fid);
  if R.verbose,fprintf('[fc-vfemp1] uninstall file list for addon %s written in\n    -> %s\n',R.name,filename);end
  
  if isOctave
    % rehash not works
    fprintf('\n[fc-vfemp1] Needs restart Octave for using <%s> add-on! ***\n',R.name)
  else
    eval(['Ver=fc_vfemp1.addon.',R.name,'.version();']);
    fprintf('[fc-vfemp1] Addon %s version %s successfully installed\n',R.name,Ver);
  end
end
