function plots3D(Th,U,Phi,V)
  %fc_tools.graphics.monitors.onGrid(3,3,'figures',1:8,'covers',0.9);
  interpreter=@(x) fc_tools.graphics.interpreter(x);
  if fc_tools.comp.isOctave(),opt_interp={'interpreter','tex'};else,opt_interp={'interpreter','latex'};end

%    options=fc_tools.graphics.DisplayFigures('nfig',8);
%    interpreter=@(x) fc_tools.graphics.interpreter(x);
  isorange=linspace(min(Phi),max(Phi),20);
  isOctave=fc_tools.comp.isOctave();

  figure(1)
  Th.plotmesh('d',2,'inlegend',true,'EdgeColor','none')
  xlabel('x'),ylabel('y'),zlabel('z')
  axis image
  legend('show')
    
  figure(2)
  Th.plotmesh('d',2,'inlegend',true,'EdgeColor','none','labels',[10,11,31,1000,1020,1021,2000,2020,2021])
  xlabel('x'),ylabel('y'),zlabel('z')
  axis image
  legend('show')
  view([-80.5,10])
  
    
  P1=fc_tools.graphics.PlaneCoefs([0 0 1],[0 0 1]);
    
  figure(3)
  Th.plot(Phi,'d',2,'FaceColor','interp','EdgeColor','none')
  hold on,axis off,axis image
  Th.plotmesh('d',1,'Color','k','Linewidth',1.5)
  Th.plotiso(Phi,'isorange',isorange,'Color','w')
  colorbar()
  set(get(colorbar(),'title'),'string',interpreter('$\phi$'),opt_interp{:})
  if ~isOctave,camzoom(1.3);end

  figure(4)
  Th.plot(Phi,'d',2,'labels',[10,11,31,1000,1020,1021,2000,2020,2021],'FaceColor','interp','EdgeColor','none')
  hold on,axis off,axis image
  Th.plotmesh('d',1,'Color','k','Linewidth',1.5)
  Th.plotiso(Phi,'labels',[10,11,31,1000,1020,1021,2000,2020,2021],'isorange',isorange,'Color','w')
  Th.slice(Phi,P1,'FaceColor','interp')
  Th.sliceiso(Phi,P1,'isorange',isorange,'Color','w')
  set(get(colorbar(),'title'),'string',interpreter('$\phi$'),opt_interp{:})
  view(-35,26)
  if ~isOctave,camzoom(1.3);end

  isorange=linspace(min(U),max(U),20);
  figure(5)
  colormap(jet)
  Th.plot(U,'d',2,'FaceColor','interp','EdgeColor','none')
  hold on,axis off,axis image
  Th.plotmesh('d',1,'Color','k','Linewidth',1.5)
  Th.plotiso(U,'isorange',isorange,'Color','w')
  colorbar()
  set(get(colorbar(),'title'),'string',interpreter('$u$'),opt_interp{:})
  if ~isOctave,camzoom(1.3);end
  
  figure(6)
  colormap(jet)
  Th.plot(U,'d',2,'labels',[10,11,31,1000,1020,1021,2000,2020,2021],'FaceColor','interp','EdgeColor','none')
  hold on,axis off,axis image
  Th.plotmesh('d',1,'Color','k','Linewidth',1.5)
  Th.plotiso(U,'labels',[10,11,31,1000,1020,1021,2000,2020,2021],'isorange',isorange,'Color','w')
  P1=fc_tools.graphics.PlaneCoefs([0 0 1],[0 0 1]);
  Th.slice(U,P1,'FaceColor','interp')
  Th.sliceiso(U,P1,'isorange',isorange,'Color','w')
  set(get(colorbar(),'title'),'string',interpreter('$u$'),opt_interp{:})
  view(-35,26)
  if ~isOctave,camzoom(1.3);end
  
  VelocityMagnitude=sqrt(V{1}.^2+V{2}.^2+V{3}.^2);
  mV=max(VelocityMagnitude);
  
  figure(7)
  colormap(jet)
  Th.plotmesh('d',2,'labels',[10,11,31],'FaceColor',0.8*[1,1,1],'EdgeColor',0.9*[1,1,1])
  hold on,axis off,axis image
  Th.plotquiver(V,'colordata',U,'scale',1.3*Th.get_h()/mV,'freq',1)
  Th.plotmesh('d',1,'Color','k','Linewidth',1.5)
  colorbar()
  set(get(colorbar(),'title'),'string',interpreter('$u$'),opt_interp{:})
  view(84,-84)
  if ~isOctave,camzoom(1.3);end
  
  figure(8)
  colormap(jet)
  Th.plotmesh('d',2,'labels',[10,11,31],'FaceColor',0.8*[1,1,1],'EdgeColor',0.9*[1,1,1])
  hold on,axis off,axis image
  Th.plotquiver(V,'colordata',U,'scale',2*Th.get_h()/mV,'freq',2)
  %caxis([min(U),max(U)])
  Th.plotmesh('d',1,'Color','k','Linewidth',1.5)
  axis image, axis off
  view([-80.5,10])
  if ~isOctave,camzoom(1.3);end
  colorbar()
  set(get(colorbar(),'title'),'string',interpreter('$u$'),opt_interp{:})
  
  fc_tools.graphics.monitors.autoGrid('covers',0.9);
end
